import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { HjmViolation, HjmViolationParam } from './model';

/**
 * 分页查询黄家明_违章记录
 */
export async function pageHjmViolation(params: HjmViolationParam) {
  const res = await request.get<ApiResult<PageResult<HjmViolation>>>(
    '/hjm/hjm-violation/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询黄家明_违章记录列表
 */
export async function listHjmViolation(params?: HjmViolationParam) {
  const res = await request.get<ApiResult<HjmViolation[]>>(
    '/hjm/hjm-violation',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加黄家明_违章记录
 */
export async function addHjmViolation(data: HjmViolation) {
  const res = await request.post<ApiResult<unknown>>(
    '/hjm/hjm-violation',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改黄家明_违章记录
 */
export async function updateHjmViolation(data: HjmViolation) {
  const res = await request.put<ApiResult<unknown>>(
    '/hjm/hjm-violation',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除黄家明_违章记录
 */
export async function removeHjmViolation(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-violation/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除黄家明_违章记录
 */
export async function removeBatchHjmViolation(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/hjm/hjm-violation/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询黄家明_违章记录
 */
export async function getHjmViolation(id: number) {
  const res = await request.get<ApiResult<HjmViolation>>(
    '/hjm/hjm-violation/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
